//-----------------------------------------------------------------------------
//	CANRlN^iRS-232j								A.Fukumori	2007/07/24
//
//-----------------------------------------------------------------------------
// ڑdl
//
//	------ CN3 ---------	------ CN4 ---------	
//													
//	10	A-		GND			1	----	----		
//	9	A+		----		2	P6-0	----		
//	8	P5-0	TxD			3	P6-1	----		
//	7	P5-1	RxD			4	P6-2	----		
//	6	P5-2	---			5	P6-3	----		
//	5	P5-3	----		6	P6-4	----		
//	4	P5-4	----		7	P6-5	----		
//	3	P5-5	----		8	P6-6	----		
//	2	P5-6	----		9	P6-7	----		
//	1	P5-7	----		10	GND		----			
//
//-----------------------------------------------------------------------------
//#include "iodefine.h"


//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
int RS_Init(unsigned int dly);
void RS_SetTxD(unsigned char bit);
unsigned char RS_GetRxD(void);
void RS_Delay(unsigned int dly);
int RS_Put(unsigned char data);
unsigned char RS_Get(void);

unsigned int RS_DelayBPS;

//-----------------------------------------------------------------------------
//	C^[tF[X̏
//-----------------------------------------------------------------------------
int RS_Init(unsigned int dly)
{
	//|[g̏s
	//Configure port P5
	IO.PCR5			= 0xFD;	// 1111 1101
	//Initialize port P5
	IO.PDR5.BYTE	= 0x01;	// 0000 0000

	RS_DelayBPS = dly;
	return 0;
}

//-----------------------------------------------------------------------------
//	rbgM
//-----------------------------------------------------------------------------
void RS_SetTxD(unsigned char bit)
{
	if(bit)
		IO.PDR5.BYTE |= 0x01;
	else
		IO.PDR5.BYTE &= 0xFE;
}

//-----------------------------------------------------------------------------
//	rbgM
//-----------------------------------------------------------------------------
unsigned char RS_GetRxD(void)
{
	if(IO.PDR5.BYTE & 0x02)	// RxD̃rbgMSBɃZbg
	return 0x80;
	return 0x00;
}

//-----------------------------------------------------------------------------
//	EGCg	1/9600bps=104usec
//-----------------------------------------------------------------------------
void RS_Delay(unsigned int dly)
{
	while(dly) dly--;
}

//-----------------------------------------------------------------------------
//	M
//-----------------------------------------------------------------------------
int RS_Put(unsigned char data)
{
	char i;

	RS_SetTxD(0);			// X^[grbg̑M
	RS_Delay(RS_DelayBPS);	// PNbÑEGCg
	
	for(i=0;i<8;i++)	// f[^LSB瑗M
	{
		RS_SetTxD(data&0x01);	// LSB𑗐M
		RS_Delay(RS_DelayBPS);	// PNbÑEGCg
		data>>=1;				// PrbgVtg
	}
	RS_SetTxD(1);			// Xgbvrbg̑M
	RS_Delay(RS_DelayBPS);	// PNbÑEGCg
	return 0;
}

//-----------------------------------------------------------------------------
//	M
//-----------------------------------------------------------------------------
unsigned char RS_Get(void)
{
	char i;
	unsigned char data=0;

	while(RS_GetRxD());		// X^[grbg҂@̋Lq͊댯I

	RS_Delay(RS_DelayBPS/2);// rbg̒Sǂݍނ߁ANbNx点
	RS_Delay(RS_DelayBPS);	// PNbÑEGCg
	
	for(i=0;i<8;i++)	// f[^LSBM
	{
		data>>=1;				// f[^MSBɓǂݍނ߂PrbgVtg
		data|=RS_GetRxD();		// f[^MSBɓǂݍ
		RS_Delay(RS_DelayBPS);	// PNbÑEGCg
	}
	RS_Delay(RS_DelayBPS);	// PNbÑEGCgiXgbvrbgj
	return data;
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_RS_MODE(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_RS_SEND(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_RS_RECV(void)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_RS_MODE)
	{
		ICN[ID_RS_RECV].DATA.BYTE.B1 = RS_Get();
		ICN[ID_RS_RECV].DATA.BYTE.B2 = 0;
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_RS_MODE(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==0)
	{
		ICN[ID_RS_MODE].DATA.BYTE.B1 = low;
		ICN[ID_RS_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_RS_MODE].DATA.WORD.W1)
		{
			ICN[ID_MODE].DATA.BYTE.B1 = ID_RS_MODE;
			RS_Init(ICN[ID_RS_MODE].DATA.WORD.W1);
		}
	}
	else if(ICN[ID_MODE].DATA.BYTE.B1 == ID_RS_MODE)
	{
		ICN[ID_RS_MODE].DATA.BYTE.B1 = low;
		ICN[ID_RS_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_RS_MODE].DATA.WORD.W1==0)
		{
			ICN[ID_MODE].DATA.BYTE.B1	= 0;
			ICN[ID_P5_PU].DATA.BYTE.B1	= IO.PUCR5.BYTE;
			ICN[ID_P5_PC].DATA.BYTE.B1	= IO.PCR5;
			ICN[ID_P5_DI].DATA.BYTE.B1	= IO.PDR5.BYTE;
			ICN[ID_P5_DO].DATA.BYTE.B1	= IO.PDR5.BYTE;
		}
		else
		{
			RS_DelayBPS = ICN[ID_RS_MODE].DATA.WORD.W1;
		}
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_RS_SEND(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_RS_MODE)
	{
		ICN[ID_RS_SEND].DATA.BYTE.B1 = low;
		ICN[ID_RS_SEND].DATA.BYTE.B2 = 0;
		RS_Put(low);
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_RS_RECV(unsigned char low ,unsigned char hi)
{

}

