//-----------------------------------------------------------------------------
//	ICN_Open_cpp										A.Fukumori	2007/07/15
//
//	vgRˑFICN		n[hˑFWindows, CANCard
//-----------------------------------------------------------------------------
//	2007/05/19	A.Fukumori	ŁiCANUPC̓΍j
//	2007/05/19	A.Fukumori	ICNgpCAN_Openł͂ȂICN_OpenĂяo
//	2007/05/24	A.Fukumori	CAN_Open
//	2007/05/26	A.Fukumori	JI
//	2007/06/02	A.Fukumori	ICNUPC̋ʉiICNNPA͐tō݉\j


//-----------------------------------------------------------------------------
//	include
//-----------------------------------------------------------------------------
#include	<windows.h>		// Windows:	Sleep()
#include	<stdio.h>		// C:		printf()
#include	<mmsystem.h>	// Windows:	timeGetTime()
#include	"sim.h"
#include	"IFCan.h"		// CANCard:	...
#include	"IFCANPF.h"		// CANCard:	...
#include	"ICN.h"


//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
struct tICN_IF
{
	char		Name[7];
	HANDLE		hDeviceHandle;
}
ICN_IF[ICN_IF_MAX] = 
{
	"IFCAN1",0,	// 1
	"IFCAN2",0	// 2
};
			int				ICN_IF_cnt = 2;	// o^
			unsigned long	ICN_Time = 0;
			HANDLE			hDeviceHandle[512]={0};


//-----------------------------------------------------------------------------
// CAN C^tF[X̃I[vs܂B
//-----------------------------------------------------------------------------
int	ICN_Open	(unsigned long	MAC,
				 char*			pName,
				 unsigned long	BaudRate,
				 char*			String)
{
	CAN_PORT_CONFIG		Conf;
	int					i;
	int					nRet;

//	printf("in\t: ICN_Open(CAN C^tF[X̃I[vs܂B)\n");

	if(!ICN_Time)
	{
		ICN_Time = timeGetTime();
	}

	if(String[0])
	{
		printf(	"ICN_Open(%ld,%s,%ld,%s)\n",
				MAC,
				pName,
				BaudRate,
				String);
	}

	for(i=0;i<ICN_IF_cnt;i++)
	{
		if(!strncmp(pName,ICN_IF[i].Name,6))
		{
			if(ICN_IF[i].hDeviceHandle)
			{
				hDeviceHandle[MAC] = ICN_IF[i].hDeviceHandle;
				return 0;
			}
			else
			{
#ifndef SimCAN
				ICN_IF[i].hDeviceHandle = CanOpenPort(pName);//CAN|[gI[v
#else
				Sleep(1);
				ICN_IF[i].hDeviceHandle = (HANDLE)1;
#endif
				hDeviceHandle[MAC] = ICN_IF[i].hDeviceHandle;
				break;
			}
		}
	}

	if(!hDeviceHandle[MAC])
	{
		if(ICN_IF_cnt>=ICN_IF_MAX)
		{
			printf("error\t: ICN_Open(ICN_IFzs)\n");
			return 1;
		}
#ifndef SimCAN
		ICN_IF[i].hDeviceHandle = CanOpenPort(pName); // CAN|[gI[v
#else
		Sleep(1);
		ICN_IF[i].hDeviceHandle = (HANDLE)1;
#endif
		hDeviceHandle[MAC] = ICN_IF[i].hDeviceHandle;
		strcpy(ICN_IF[i].Name,pName);
		ICN_IF_cnt++;
	}

	if( hDeviceHandle[MAC] == INVALID_HANDLE_VALUE )
	{
		printf("error\t: ICN_Open(CAN|[gI[vs)\n");
		return 1;
	}

#ifndef SimCAN
	CanClearBuffer(hDeviceHandle[MAC], CAN_CLEAR_TXB);	// Mobt@NA
	CanClearBuffer(hDeviceHandle[MAC], CAN_CLEAR_RXB);	// Mobt@NA
	CanClearBuffer(hDeviceHandle[MAC], CAN_CLEAR_ERB);	// G[obt@NA
	CanClearBuffer(hDeviceHandle[MAC], CAN_CLEAR_TIMERCOUNTER);	// JE^
	CanDeactivate(hDeviceHandle[MAC]);						// oXIt
	CanClearBuffer(hDeviceHandle[MAC], CAN_CLEAR_TXERR);	// MG[JE^
	CanClearBuffer(hDeviceHandle[MAC], CAN_CLEAR_RXERR);	// MG[JE^

	CanGetConfig(hDeviceHandle[MAC], &Conf);
	Conf.ulLineMode = CAN_NORMAL_MODE;		// ʏ탂[h
	Conf.ulBaudRate = BaudRate;				// ʐMx

	nRet = CanSetConfig(hDeviceHandle[MAC], &Conf);
#else
	Sleep(1);
	nRet = IFCAN_ERROR_SUCCESS;
#endif
	if(nRet)
	{
		printf("error\t: ICN_Open(CANݒ莸s)\n");
		return nRet;
	}

#ifndef SimCAN
	nRet = CanActivate(hDeviceHandle[MAC]);		// CANoXɐڑ
#else
	Sleep(1);
	nRet = IFCAN_ERROR_SUCCESS;
#endif
	if(nRet)
	{
		printf("error\t: ICN_Open(CANoXڑs)\n");
		return nRet;
	}

//	printf("out\t: ICN_Open(CAN C^tF[X̃I[vs܂B)\n");
	return 0;
}
