//-----------------------------------------------------------------------------
//	ICN_Status_cpp										A.Fukumori	2007/07/15
//
//	vgRˑFICN		n[hˑFWindows, CANCard
//-----------------------------------------------------------------------------
//	2007/07/11	A.Fukumori	


//-----------------------------------------------------------------------------
//	include
//-----------------------------------------------------------------------------
#include	<windows.h>		// Windows:	Sleep()
#include	<stdio.h>		// C:		printf()
#include	"sim.h"
#include	"IFCan.h"		// CANCard:	...
#include	"IFCANPF.h"		// CANCard:	...
#include	"ICN.h"


//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
extern		unsigned long	ICN_Time;
extern		HANDLE			hDeviceHandle[512];


//-----------------------------------------------------------------------------
// CAN C^tF[X̃Xe[^X\܂B
//-----------------------------------------------------------------------------
int	ICN_Status	(unsigned long	MAC)
{
	CAN_PORT_STATUS		pStatus;
	int					nRet;

//	printf("in\t: ICN_Status(CAN C^tF[X̃Xe[^X\܂B)\n");

#ifndef SimCAN
	nRet = CanGetStatus(hDeviceHandle[MAC],&pStatus);	// Xe[^X
#else
	Sleep(1);
	nRet					= IFCAN_ERROR_SUCCESS;
	pStatus.ulBusStatus		= CAN_BUS_ACTIVE;
	pStatus.ulRXBCount		= 0;
	pStatus.ulTXBCount		= 0;
	pStatus.ulERBCount		= 0;
	pStatus.ulRXERRCount	= 0;
	pStatus.ulTXERRCount	= 0;
#endif
	if(nRet)
	{
		printf("error\t: ICN_Status(擾s)\n");
		return nRet; // G[
	}

	switch(pStatus.ulBusStatus)
	{
	case CAN_BUS_ACTIVE:
		printf("<oXANeBu>\t");
		printf(" M=%d,"		,pStatus.ulTXBCount);
		printf(" M=%d,"		,pStatus.ulRXBCount);
		printf(" MG[=%d,"	,pStatus.ulTXERRCount);
		printf(" MG[=%d\n"	,pStatus.ulRXERRCount);
		break;
	case CAN_BUS_PASSIVE:
		printf("<oXpbVu>\t");
		printf(" M=%d,"		,pStatus.ulTXBCount);
		printf(" M=%d,"		,pStatus.ulRXBCount);
		printf(" MG[=%d,"	,pStatus.ulTXERRCount);
		printf(" MG[=%d\n"	,pStatus.ulRXERRCount);
		break;
	case CAN_BUS_OFF:
		printf("<oXIt>\t");
		printf(" M=%d,"		,pStatus.ulTXBCount);
		printf(" M=%d,"		,pStatus.ulRXBCount);
		printf(" MG[=%d,"	,pStatus.ulTXERRCount);
		printf(" MG[=%d\n"	,pStatus.ulRXERRCount);
		break;
	default:
		printf("<ԕs>\t");
		printf(" M=%d,"		,pStatus.ulTXBCount);
		printf(" M=%d,"		,pStatus.ulRXBCount);
		printf(" MG[=%d,"	,pStatus.ulTXERRCount);
		printf(" MG[=%d\n"	,pStatus.ulRXERRCount);
		break;
	}

//	printf("out\t: ICN_Status(CAN C^tF[X̃Xe[^X\܂B)\n");
	return 0;
}
