//-----------------------------------------------------------------------------
//	ICN_Send_cpp										A.Fukumori	2007/07/15
//
//	vgRˑFICN		n[hˑFWindows, CANCard
//-----------------------------------------------------------------------------
//	2007/07/01	A.Fukumori	


//-----------------------------------------------------------------------------
//	include
//-----------------------------------------------------------------------------
#include	<windows.h>
#include	<stdio.h>		// C:		printf()
#include	<mmsystem.h>	// Windows:	timeGetTime()
#include	"sim.h"
#include	"IFCan.h"		// CANCard:	...
#include	"IFCANPF.h"		// CANCard:	...
#include	"ICN.h"


//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
extern		unsigned long	ICN_Time;
extern		HANDLE			hDeviceHandle[512];
extern		ICN_BOX			icn_box[512];


//-----------------------------------------------------------------------------
//	ICN bZ[W̑Ms܂B
//-----------------------------------------------------------------------------
inline int	ICN_Send	(unsigned long	MAC,
						 PIFCAN_MESSAGE	pMessage,
						 unsigned long	ulCount,
						 char*			String)
{
	unsigned long		Time;
	int					nRet;

	int					i;
	int					mac;
	int					id,id1,id2,id3;
	int					data;

//	printf("in\t: ICN_Send(ICNbZ[W̑Ms܂B)\n");	

#ifndef SimCAN
	nRet = CanSendMessage(hDeviceHandle[MAC],(PCAN_MESSAGE)pMessage,ulCount);
#else
	Sleep(1);
	nRet = IFCAN_ERROR_SUCCESS;
#endif
	if(nRet)
	{
		printf("error\t: ICN_Send(CANbZ[WMs)\n");
		return nRet;
	}

	Time = timeGetTime()-ICN_Time;

	for(i=0;i<(int)ulCount;i++)
	{
		switch(pMessage[i].ulLength)
		{
		case 8:
			if(pMessage[i].bData[4]&0x01)
			{
				mac		= pMessage[i].ulID;
				id		= pMessage[i].bData[5];
				data	= pMessage[i].bData[6]|pMessage[i].bData[7]<<8;

				icn_box[mac].ID[id].TX_Time		= Time;
				icn_box[mac].ID[id].Enable		= 0;

				if(String[0])
				{
					printf(	"TX:<%s>\tT=%ld, CAN=%3d, ID=%3d, DATA=%d\n",
							String,
							Time,
							mac,
							id,
							data);
				}
			}
			else
			{
				mac		= pMessage[i].ulID;
				id1		= pMessage[i].bData[5];
				id2		= pMessage[i].bData[6];
				id3		= pMessage[i].bData[7];

				icn_box[mac].ID[id1].TX_Time	= Time;
				icn_box[mac].ID[id2].TX_Time	= Time;
				icn_box[mac].ID[id3].TX_Time	= Time;
				icn_box[mac].ID[id1].Enable		= 0;
				icn_box[mac].ID[id2].Enable		= 0;
				icn_box[mac].ID[id3].Enable		= 0;

				if(String[0])
				{
					printf(	"TX:<%s>\tT=%ld, CAN=%3d, ID=%3d, ID=%d, ID=%d\n",
							String,
							Time,
							mac,
							id1,
							id2,
							id3);
				}
			}
		case 4:
			if(pMessage[i].bData[0]&0x01)
			{
				mac		= pMessage[i].ulID;
				id		= pMessage[i].bData[1];
				data	= pMessage[i].bData[2]|pMessage[i].bData[3]<<8;

				icn_box[mac].ID[id].TX_Time		= Time;
				icn_box[mac].ID[id].Enable		= 0;

				if(String[0])
				{
					printf(	"TX:<%s>\tT=%ld, CAN=%3d, ID=%3d, DATA=%d\n",
							String,
							Time,
							mac,
							id,
							data);
				}
			}
			else
			{
				mac		= pMessage[i].ulID;
				id1		= pMessage[i].bData[1];
				id2		= pMessage[i].bData[2];
				id3		= pMessage[i].bData[3];

				icn_box[mac].ID[id1].TX_Time	= Time;
				icn_box[mac].ID[id2].TX_Time	= Time;
				icn_box[mac].ID[id3].TX_Time	= Time;
				icn_box[mac].ID[id1].Enable		= 0;
				icn_box[mac].ID[id2].Enable		= 0;
				icn_box[mac].ID[id3].Enable		= 0;

				if(String[0])
				{
					printf(	"TX:<%s>\tT=%ld, CAN=%3d, ID=%3d, ID=%d, ID=%d\n",
							String,
							Time,
							mac,
							id1,
							id2,
							id3);
				}
			}
			break;
		default:
			printf("error\t: ICN_Send(vgRᔽ)\n");
			break;
		}
	}

//	printf("out\t: ICN_Send(ICNbZ[W̑Ms܂B)\n");
	return nRet;
}
